/*

           Welcome in the Xref-Speller Java testing program for Kawa!

    First of all read the README file in order to install the Xref-Speller
    plug-ins into your Kawa environement.
	
	IMPORTANT! Verify that you have an open project when you are using
	Xref-Speller. If there is no open project it will not work.

    Then move to the 'demoFunction' method and follow hints in commentaries.

*/

import java.awt.*;

class Test {
  int      classVar1;
  double   classVar2;

  int      onlyVarOfThisClassOnO;

  void          funNoArg()            {  }
  int           fun1Arg( int i )      { return(0); }

  int           fun1Arg( double x )   { return(1); }
  static int    fun1StaticNoArg()      { return(1); }
  static int    fun2StaticNoArg()      { return(1); }

  static Button myButton;

  void demoFunction(int demoArg1, String demoArg2) {

    /*

                           HERE WE ARE !

	  please, pass all of the following examples in order
	  to be sure, that your Xref environment is correctly
	  set.

    */


    //  positioning the cursor at the end of the following line
    //  and seelcting the Completion item of the 'Plug-ins' menu item
    //  gives you the info about the symbol's type.

    classVar1
    ;
    fun1Arg
    ;

    //  In the following example (if your JDKCLASSPATH 
	//  environment variable is correctly set),
    //  you will see all posible profiles of the method 
    //  'println' of the standard 'java.io.PrintStream' class

    System.out.println
    ;


      


    //  positioning the cursor at the end of following lines
    //  and selecting Completion will give you the list of possible 
    //  completions of given identifiers
      
    fun
    ;
    demo
    ;


    //  positioning the cursor at the end of following lines
    //  and selecting the Completion will complete identifiers (as there is
    //  just one possible completion in this context).

    Sys
    ;

    //  in this context the Completion will help you to browse the
    //  CLASSPATH directories structure

    java.
    ;
    java.lang.System.
    ;

	//                      SOURCE BROWSING

	// IMPORTANT: Before starting to use Xref source browser you should 
	// create tags file for your project. To do this execute the
	// 'Create Xref Tag File' plugin! This file must be included
	// in the currently opened project.

	// positioning  the  cursor  on  an  identifier on  following  lines  and
	// selecting 'PushAndGotoDefinition'  will move you to  the definition of
	// the referenced  symbol. Then using repeatedly  the 'NextReference' and
	// 'PreviousReference'  plug-ins you can  move to  the next  and previous
	// reference of  this symbol.  After all  you can return  by pressing the
	// 'PopAndReturn' key.
	// 
	// Symbol's lookup is the one  defined in the Java Language Specification
	// including  name lookup rules,  accessibility and  applicability checks
	// and overloading resolution.
	// 
	// The  'PushAndGotoDefinition'  is pushing  references  of the  selected
	// symbol on  am internal reference stack, 'PopAndReturn'  pops them.  It
	// means, that you can push several symbols (without returning by Pop) in
	// order  to  inspect  several   symbols,  then  pressing  several  times
	// 'PopAndReturn' will put you back to the original place.

    classVar1=0;

    fun1Arg(0);					// fun1Arg( INT )
    fun1Arg(2.0);				// fun1Arg( DOUBLE )

    demoArg1=0;

    demoFunction(0,"toto");

    // yes, you can go to the definition of this 'Test' class as well:

    Test.
    fun1StaticNoArg();


    //  Using the 'PushAndListReferences' you can list all references of
    //  the given symbol in a separate window. Just set the cursor on
    //  a symbol and then invoke this plug-in. You can then move 
    //  directly to any reference by double-clicking left mouse button on
    //  a specified line of this list.
    //  For example, get the list of all references of the 'Test' symbol.

    Test

    .fun1StaticNoArg();


    //  positioning the cursor on the following identifier 'size'
    //  and invoking the 'SearchAbout' plug-in.
    //  will search all possible completions, and displaying
    //  those containing (case insensitive) the string 'size'.

    myButton. size
    ;


    //  Here are some others examples on how, the 'Completion' works
    //  in different contexts.

    // static usage via class name
    Test.
    ;

    // non-static usage via this instance
    this.
    ;
    

  }

  public static void main( String args[] ) {

    //  call from a static method  ->  only static members are visible
    fun
    ;

  }
  Test(int constructorArgument) {

    //  call from a non-static method -> all members are visible
    fun
    ;


    /*
                       The presentation is over.


           You can now check Xref-Speller on your project.

    */

    classVar1 = constructorArgument;
  }
}
