package sk.xref.kawa;

import java.io.*;
import com.tektools.kawa.plugin.*;

public class XrefProcess {
	
	public Process pp = null;
	public OutputStream oo = null;
	public InputStream ii = null;
	
	public void killThis() {
		if (pp!=null) {
			pp.destroy();
			pp = null;
		}
		if (oo != null) {
			try {oo.close();} catch (IOException e) {}
			oo = null;
		}
		if (ii != null) {
			try {ii.close();} catch (IOException e) {}
			ii = null;
		}
	}
	
	public XrefProcess() {
		try {
//			KawaApp.build.println("Creating new xref process");
			Runtime rt = Runtime.getRuntime();
			pp = rt.exec("xref.exe -task_regime_server");
			oo = pp.getOutputStream();
			ii = pp.getInputStream();
//			System.runFinalizersOnExit(true);
		} catch (IOException e) { 
//			KawaApp.build.println("sorry, must kill it");
			killThis(); 
		}
	}
	
	protected void finalize() throws Throwable {
		killThis();
	}
		
}