/*

               Welcome in the Xrefactory Java testing program!

    Please move to the 'demoFunction' method and follow hints in commentaries.

*/

import java.awt.*;

class Test {
  int      classVar1;
  double   classVar2;

  int      onlyVarOfThisClassOnO;

  void          funNoArg()            {  }
  int           fun1Arg( int i )      { return(0); }

  int           fun1Arg( double x )   { return(1); }
  static int    fun1StaticNoArg()      { return(1); }
  static int    fun2StaticNoArg()      { return(1); }

  static Button myButton;
  Component comp;
  FileDialog fdialog;

  void demoFunction(int demoArg1, String demoArg2) {

    /*

                           HERE WE ARE !

        The  first thing  you have  to do  (if not  yet done)  is to
        create  a  new  Xrefactory   project.   To  do  this  select
        "Xref->Project->New"  item from the  (X)Emacs menu  bar.  It
        will pose  you some questions,  just answer them  by default
        (proposed) values.  Now  you should invoke the "Xref->Create
        Xref   Tags   File"   menu   item   in   order   to   create
        cross-references for  this project.  The F7 key  deletes the
        new window  after.  Note that any of  functions presented in
        following examples can be  accesses via the 'Xref' menu item
        on the top of your Emacs/XEmacs screen.
	*/


	  /*

                        CODE COMPLETION

        positioning the cursor at the end of following lines
        and pressing F8 (complete identifier) will give you the 
        list of all possible completions of given identifiers
        (after, press F7 to delete the created window)
        NOTE that each line in showed window is divided into three 
        fields containing:
        1.) the string proposed for the completion, 
        2.) the class (if any) from where the symbol comes 
            (together with its 'inheritence level') 
        3.) the declaration of the symbol (i.e. its type and profile).

        Completion fields are active, with middle mouse button you can
        inspect symbol's definition, the right button moves you back
        and inserts the completion. On some systems simultaneous
        pressing of both buttons works instead of button2.

	*/

    fun
    ;
    classVar
    ;
    demo
    ;


    //  positioning the cursor at the end of following lines
    //  and pressing F8 will complete identifiers (as there is
    //  just one possible completion in this context).

    Sys
    ;
    System.o
    ;

    //  positioning the cursor at the end of the following line
    //  and pressing F8 will insert a partial completion, when pressing
    //  the F8 one more time, you will get the list of possible
    //  completions (after, press F7 to delete the created window)

    System.out.pr
    ;

    //  in the following context the F8 key will help you to browse the
    //  CLASSPATH directories structure

    java.
    ;
    java.lang.System.
    ;

//      If the symbol to complete is yet complete an info about its
//      type is displayed. For example positioning the cursor at the
//      end of the following line
//      and pressing F8 will give you the info about the symbol's type.
//      In this case, you will see all posible profiles for the
//      method 'println' of the standard 'java.io.PrintStream' class

    System.out.println
    ;


	/*
                    SOURCE BROWSING
	*/





    //  positioning the cursor on identifiers of following lines
    //  and pressing F6 will move you to the definition of the referenced
    //  symbol. Then using repeatedly the 'F4'
    //  and 'F3' keys you can move to the next and previous
    //  reference of the symbol. After all you can return by
    //  pressing the 'F5' key.
    //        Symbol's lookup is the one defined in the Java Language 
    //  Specification including name lookup rules and overloading resolution.
    //  This can be check on the fun1Arg method invocations.
    //      F6 is pushing references of the selected symbol on a
    //  reference stack, F5 pops them. It means, that you can hit
    //  F6 several times (without returning by F5) in order to inspect
    //  several symbols, then pressing several times F5 will put you back
    //  to the original place.

    classVar1=0;

    fun1Arg(0);					// fun1Arg( INT )
    fun1Arg(2.0);				// fun1Arg( DOUBLE )

    demoArg1=0;

    demoFunction(demoArg1,"toto");

    // you can go to the definition of this 'Test' class as well:

    Test.
    fun1StaticNoArg();

    // if you try to browse a symbol which can't be unambiguously
    // resolved (due to the virtuality) Xrefactory asks you for
    // manual resolution of applications which you wish to browse.
    // In the next example positioning the cursor on the addNotify
    // symbol and pressing F6 (push references) will pop a menu
    // where you can manually resolve applications
    // you desire to browse. The proposed menu contains information
    // about the number of references available and class subtree
    // for given virtual method. In the menu choose the references
    // using the space key then push the selected references by 
    // the <CR> key.

    comp.addNotify();

    // note, that there is no ambiguity on the following application
    // of the addNotify method.

    fdialog.addNotify();

    //  You can list all references of
    //  the given symbol in a separate window. Just set the cursor on
    //  a symbol and then invoke 'List and Push References' item from
    //  the 'Xref' menu (or invoke 'xref-listCxrefs' elisp function).
    //  You can now move 
    //  directly to any reference by clicking the middle mouse button on
    //  a specified line of this list. If you have no mouse you can do the
    //  same by placing the cursor on a reference and then pressing the
    //  ' ' <SPACE> key. 
    //  As in previous cases, you can move to the previous and next reference
    //  by F3 and F4 keys, as well as pop references and return back to 
    //  the initial point by the F5 key.
    //  For example, get the list of all references of the 'Test' symbol.

    Test

    .fun1StaticNoArg();

	// you can filter showed references by pressing the '+' or '-'
    // keys. In this case only "more important" references are listed.
    // see the documentation for more info about filter levels.


    //  positioning the cursor on the following identifier 'size'
    //  and invoking the 'Search symbol in context completions'
    //  (or 'xref-search-in-completions' e-lisp function)
    //  will search all possible completions, and displaying
    //  those containing (case insensitive) the string 'size'.
    //  (after, press F7 to delete the created window)

    myButton. size
    ;


    /*
                         REFACTORINGS.
    */


    /*                Symbol renaming.
        In order to rename a symbol, set the cursor on it and select the 
        "Safe Rename" item from 'Xref' menu, (or invoke the 'xref-rename' 
        e-lisp function). For example, try to rename the 'demoArg1' argument 
        starting at the following occurence:
    */

    classVar1 = demoArg1;	


    // You can rename any kind of symbol in the same way,
    // namely variables, fields, methods, class names ...

    /*                       Argument manipulations.
       positioning the cursor on the following function name 'demoFunction'
       and selecting one of argument manipulations will
       apply this refactoring on all references of the given function.
       When selecting an argument manipulation
       you will be prompted for the order of argument in cause,
       so just enter the corresponding number. For example to
       exchange first and second arguments of the 'demoFunction', 
       put the cursor on the 'demoFunction' symbol, invoke the 
       'xref exchange argument' refactoring and then
       insert '1' at the first prompt and insert '2' at the second 
       prompt. Then you should confirm with 'y' key the application
       of each operation.
       Similarly you can try to delete an argument or simply browsing 
       all function invocations with having the cursor positionned on 
       a particular argument.
    */

    demoFunction(0,"x");


  }

    /*
                     The presentation is over.


            You can now check Xrefactory on your project.
     Do not forget to switch to your project by "Project->Set Active"
                          menu item!
      You can access interactive help for any Xrefactory function by 
    typing "C-h k" and then selecting the corresponding function by mouse
                       from "Xref" Menu.

    */
}

