/*
		This program invokes the Xref-Speller source browsing
		edit macro resolving the symbol on the cursor position,
		pushing into local stack all its references, and 
		printing them into the build window.

		When invoked as Kawa Plug-in it requires the
			<File Path>
		argument.
		
		The 'xref.exe' file must be located in a directory listed in
		your PATH variable. Note that Xref-Speller is unable to read 
		compressed '.zip' and '.jar' files. In order to use it 
		efficiently, please, unzip those archives and then re-zip
		them with 'none' compression. Note that there is no need 
		to re-zip the standard class libraries such as 'classes.zip'
		or 'rt.jar' as they are distributed with none compresion.

*/

import java.io.*;	
import com.tektools.kawa.plugin.*;
import sk.xref.kawa.*;			


/** Xref-Speller source browsing kawa plugin */

class PushAndListReferences {
	
	public static void main(String[] args) {
		XrefCall.action(args, " -olcxlist ", true);
	}
	
}